/*
*	This is the header file for including overture into FronTier	
*
*	Copyright 2001 by The University at Stony Brook, All rights reserved.
*/

#if !defined(_FT_OVERTURE_H)
#define _FT_OVERTURE_H  

#if defined(__cplusplus) && defined(USE_OVERTURE)

#if defined(float)
#define float_redefined
#undef float
#endif /*defined(float)*/

/* Import header file from Overture for resolving comflict with min(), max() */
#include "Overture.h" 
#include "HDF_DataBase.h"
#include "PlotStuff.h"
#include "Ogshow.h" 

#if defined(TWOD)
#include "SquareMapping.h"
#endif /* if defined(TWOD) */

#if defined(THREED)
#include "BoxMapping.h"
#endif /* if defined(THREED) */

#include "MappedGridOperators.h"
#include "CompositeGridOperators.h"
#include "display.h"
#include "Regrid.h"
#include "ErrorEstimator.h"
#include "InterpolateRefinements.h"
#include "Ogen.h"
#include "interpolatePoints.h"

#if defined(float_redefined)
#define float double
#endif /*defined(float)*/

#endif /* if defined(__cplusplus) && defined(USE_OVERTURE) */

#endif /* _FT_OVERTURE_H */  
